## cweb 3.4g

=== Makefile ===
# This file is part of CWEB.
# It is distributed WITHOUT ANY WARRANTY, express or implied.
# Version 3.0 --- June 1993

# Copyright (C) 1987,1990,1993 Silvio Levy and Donald E. Knuth

# Permission is granted to make and distribute verbatim copies of this
# document provided that the copyright notice and this permission notice
# are preserved on all copies.

# Permission is granted to copy and distribute modified versions of this
# document under the conditions for verbatim copying, provided that the
# entire resulting derived work is given a different name and distributed
# under the terms of a permission notice identical to this one.

# 
# Read the README file, then edit this file to reflect local conditions
#

# directory for TeX inputs (cwebmac.tex goes here)
MACROSDIR= /usr/local/lib/tex/inputs

# directory for CWEB inputs in @i files
CWEBINPUTS= /usr/local/lib/cweb

# extension for manual pages ("l" distinguishes local from system stuff)
MANEXT= l
#MANEXT= 1

# directory for manual pages (cweb.1 goes here)
MANDIR= /usr/man/man$(MANEXT)

# destination directory for executables; must end in /
DESTDIR= /usr/local/bin/

# directory for GNU EMACS Lisp code (cweb.el goes here)
EMACSDIR= /usr/local/emacs/lisp

# Set DESTPREF to null if you want to call the executables "tangle" and "weave"
# (probably NOT a good idea; we recommend leaving DESTPREF=c)
DESTPREF=c

# Set CCHANGES to comm-foo.ch if you need changes to common.w
CCHANGES=

# Set TCHANGES to ctang-foo.ch if you need changes to ctangle.w
TCHANGES=

# Set WCHANGES to cweav-foo.ch if you need changes to cweave.w
WCHANGES=

# We keep debugging info around, for fun, but most users don't need it
CFLAGS = -g
#CFLAGS = -O
LINKFLAGS = -g
#LINKFLAGS = -s # for smaller (stripped) executables on many UNIX systems

# What C compiler are you using?
CC = cc

# RM and CP are used below in case rm and cp are aliased
RM= /bin/rm
CP= /bin/cp

##########  You shouldn't have to change anything after this point #######

CWEAVE = ./cweave
CTANGLE = ./ctangle
SOURCES = cweave.w common.w ctangle.w
ALMOSTALL =  common.w ctangle.w Makefile README common.c common.h ctangle.c \
	cwebman.tex cwebmac.tex examples comm-vms.ch ctang-vms.ch \
	cweav-vms.ch comm-man.ch ctang-man.ch cweav-man.ch \
	comm-pc.ch ctang-pc.ch cweav-pc.ch comm-amiga.ch \
        comm-bs.ch ctang-bs.ch cweav-bs.ch makefile.bs \
	comm-ql.ch ctang-ql.ch cweav-ql.ch readme.ql \
	comm-os2.ch cweb.1 cweb.el prod.w
ALL =  $(ALMOSTALL) cweave.w

.SUFFIXES: .dvi .tex .w

.w.tex:
	$(CWEAVE) $*

.tex.dvi:	
	tex $<

.w.dvi:
	make $*.tex
	make $*.dvi

.w.c:
	$(CTANGLE) $*

.w.o:
	make $*.c
	make $*.o

all: ctangle cweave

cautiously: ctangle
	$(CP) common.c SAVEcommon.c
	./ctangle common $(CCHANGES)
	diff common.c SAVEcommon.c
	$(RM) SAVEcommon.c
	$(CP) ctangle.c SAVEctangle.c
	./ctangle ctangle $(TCHANGES)
	diff ctangle.c SAVEctangle.c
	$(RM) SAVEctangle.c

SAVEctangle.c:
	$(CP) ctangle.c SAVEctangle.c

SAVEcommon.c:
	$(CP) common.c SAVEcommon.c

common.c: common.w $(CCHANGES)
	$(CTANGLE) common $(CCHANGES)

common.o: common.c
	$(CC) $(CFLAGS) -DCWEBINPUTS=\"$(CWEBINPUTS)\" -c common.c

ctangle: ctangle.o common.o
	$(CC) $(LINKFLAGS) -o ctangle ctangle.o common.o 

ctangle.c: ctangle.w $(TCHANGES)
	$(CTANGLE) ctangle $(TCHANGES)

cweave: cweave.o common.o
	$(CC) $(LINKFLAGS) -o cweave cweave.o common.o

cweave.c: cweave.w $(WCHANGES)
	$(CTANGLE) cweave $(WCHANGES)

doc: $(SOURCES:.w=.dvi)

usermanual: cwebman.tex cwebmac.tex
	tex cwebman

fullmanual: usermanual $(SOURCES) comm-man.ch ctang-man.ch cweav-man.ch
	make cweave
	./cweave common.w comm-man.ch
	tex common.tex
	./cweave ctangle.w ctang-man.ch
	tex ctangle.tex
	./cweave cweave.w cweav-man.ch
	tex cweave.tex

# be sure to leave ctangle.c and common.c for bootstrapping
clean:
	$(RM) -f -r *~ *.o common.tex cweave.tex cweave.c ctangle.tex \
	  *.log *.dvi *.toc *.idx *.scn core cweave.w.[12] cweave ctangle

install: all
	$(CP) cweave $(DESTDIR)$(DESTPREF)weave
	chmod 755 $(DESTDIR)$(DESTPREF)weave
	$(CP) ctangle $(DESTDIR)$(DESTPREF)tangle
	chmod 755 $(DESTDIR)$(DESTPREF)tangle
	$(CP) cweb.1 $(MANDIR)/cweb.$(MANEXT)
	chmod 644 $(MANDIR)/cweb.$(MANEXT)
	$(CP) cwebmac.tex $(MACROSDIR)
	chmod 644 $(MACROSDIR)/cwebmac.tex
	$(CP) cweb.el $(EMACSDIR)
	chmod 644 $(EMACSDIR)/cweb.el

bundle: $(ALL)
	sed -n '1,2200 p' cweave.w > cweave.w.1
	sed -n '2201,$$ p' cweave.w > cweave.w.2
	/usr/local/bin/shar -m100000 -c -v -f cweb $(ALMOSTALL) cweave.w.[12]

tags: $(ALL)
	etags -z $(ALL)

cweb.tar: $(ALL)
	tar cvhf cweb.tar $(ALL)

floppy: $(ALL)
	bar cvhf /dev/rfd0 $(ALL)
	bar tvf /dev/rfd0
	eject

## cweb 3.64

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # This file is part of CWEB.
 # It is distributed WITHOUT ANY WARRANTY, express or implied.
-# Version 3.0 --- June 1993
+# Version 3.63 --- January 2001
 
-# Copyright (C) 1987,1990,1993 Silvio Levy and Donald E. Knuth
+# Copyright (C) 1987,1990,1993,2000 Silvio Levy and Donald E. Knuth
 
 # Permission is granted to make and distribute verbatim copies of this
 # document provided that the copyright notice and this permission notice
@@ -18,7 +18,7 @@
 #
 
 # directory for TeX inputs (cwebmac.tex goes here)
-MACROSDIR= /usr/local/lib/tex/inputs
+MACROSDIR= /usr/local/texmf/tex/generic
 
 # directory for CWEB inputs in @i files
 CWEBINPUTS= /usr/local/lib/cweb
@@ -62,21 +62,26 @@
 RM= /bin/rm
 CP= /bin/cp
 
+# uncomment the second line if you use pdftex to bypass .dvi files
+PDFTEX = dvipdfm
+#PDFTEX = pdftex
+
 ##########  You shouldn't have to change anything after this point #######
 
 CWEAVE = ./cweave
 CTANGLE = ./ctangle
 SOURCES = cweave.w common.w ctangle.w
-ALMOSTALL =  common.w ctangle.w Makefile README common.c common.h ctangle.c \
-	cwebman.tex cwebmac.tex examples comm-vms.ch ctang-vms.ch \
+ALL =  common.w ctangle.w cweave.w prod.w \
+	Makefile common.c common.h ctangle.c \
+	cwebman.tex cwebmac.tex comm-vms.ch ctang-vms.ch \
 	cweav-vms.ch comm-man.ch ctang-man.ch cweav-man.ch \
 	comm-pc.ch ctang-pc.ch cweav-pc.ch comm-amiga.ch \
         comm-bs.ch ctang-bs.ch cweav-bs.ch makefile.bs \
 	comm-ql.ch ctang-ql.ch cweav-ql.ch readme.ql \
-	comm-os2.ch cweb.1 cweb.el prod.w
-ALL =  $(ALMOSTALL) cweave.w
+	comm-w32.ch ctang-w32.ch cweav-w32.ch \
+	comm-os2.ch comm-mac.ch cweb.1 cweb.el c++lib.w README
 
-.SUFFIXES: .dvi .tex .w
+.SUFFIXES: .dvi .tex .w .pdf
 
 .w.tex:
 	$(CWEAVE) $*
@@ -94,6 +99,13 @@
 .w.o:
 	make $*.c
 	make $*.o
+
+.w.pdf:
+	make $*.tex
+	case "$(PDFTEX)" in \
+	 dvipdfm ) tex "\let\pdf+ \input $*"; dvipdfm $* ;; \
+	 pdftex ) pdftex $* ;; \
+	esac
 
 all: ctangle cweave
 
@@ -148,32 +160,36 @@
 # be sure to leave ctangle.c and common.c for bootstrapping
 clean:
 	$(RM) -f -r *~ *.o common.tex cweave.tex cweave.c ctangle.tex \
-	  *.log *.dvi *.toc *.idx *.scn core cweave.w.[12] cweave ctangle
+	  *.log *.dvi *.toc *.idx *.scn *.pdf core cweave ctangle
 
 install: all
+	- mkdir $(DESTDIR)
 	$(CP) cweave $(DESTDIR)$(DESTPREF)weave
 	chmod 755 $(DESTDIR)$(DESTPREF)weave
 	$(CP) ctangle $(DESTDIR)$(DESTPREF)tangle
 	chmod 755 $(DESTDIR)$(DESTPREF)tangle
+	- mkdir $(MANDIR)
 	$(CP) cweb.1 $(MANDIR)/cweb.$(MANEXT)
 	chmod 644 $(MANDIR)/cweb.$(MANEXT)
+	- mkdir $(MACROSDIR)
 	$(CP) cwebmac.tex $(MACROSDIR)
 	chmod 644 $(MACROSDIR)/cwebmac.tex
+	- mkdir $(EMACSDIR)
 	$(CP) cweb.el $(EMACSDIR)
 	chmod 644 $(EMACSDIR)/cweb.el
+	- mkdir $(CWEBINPUTS)
+	$(CP) c++lib.w $(CWEBINPUTS)
+	chmod 644 $(CWEBINPUTS)/c++lib.w
 
-bundle: $(ALL)
-	sed -n '1,2200 p' cweave.w > cweave.w.1
-	sed -n '2201,$$ p' cweave.w > cweave.w.2
-	/usr/local/bin/shar -m100000 -c -v -f cweb $(ALMOSTALL) cweave.w.[12]
+floppy: $(ALL) examples
+	bar cvhf /dev/rfd0 $(ALL) examples
+	bar tvf /dev/rfd0
+	eject
 
 tags: $(ALL)
-	etags -z $(ALL)
+	etags -lnone $(ALL)
 
-cweb.tar: $(ALL)
-	tar cvhf cweb.tar $(ALL)
+tarfile: $(ALL) examples
+	tar cvhf /tmp/cweb.tar $(ALL) examples
+	gzip -9 /tmp/cweb.tar
 
-floppy: $(ALL)
-	bar cvhf /dev/rfd0 $(ALL)
-	bar tvf /dev/rfd0
-	eject

=== cweb/debian/changelog ===
cweb (3.64.debian-2) unstable; urgency=low

  * Change to Architecture: all

 -- Julian Gilbey <jdg@polya.uklinux.net>  Tue,  5 Apr 2005 10:16:56 +0100

cweb (3.64.debian-1) unstable; urgency=low

  * Become a dummy package depending on tetex-bin

 -- Julian Gilbey <jdg@polya.uklinux.net>  Mon,  4 Apr 2005 23:23:34 +0100

cweb (3.64-3) unstable; urgency=medium

  * Undo the "fix" made in -2; there was a bug in mmix, not in cweb
    according to Knuth, so this actually introduced a bug.

 -- Julian Gilbey <jdg@debian.org>  Wed, 24 Apr 2002 22:38:52 +0100

cweb (3.64-2) unstable; urgency=medium

  * Fix .idx typewriter variable bug (needs underscore to be quoted;
    breaks mmix) (closes: #142502)

 -- Julian Gilbey <jdg@debian.org>  Mon, 15 Apr 2002 22:03:05 +0100

cweb (3.64-1) unstable; urgency=low

  * New upstream version incorporating several of my patches ;-)

 -- Julian Gilbey <jdg@debian.org>  Mon, 18 Mar 2002 00:19:08 +0000

cweb (3.63a-3) unstable; urgency=low

  * Suggests: ctie
  * Improved change files from TeX point-of-view.

 -- Julian Gilbey <jdg@debian.org>  Wed, 16 Jan 2002 11:28:21 +0000

cweb (3.63a-2) unstable; urgency=low

  * Heavily hacked change files now mean that CWEB is compiled against the
    kpathsea library.
  * Also a few miscellaneous bugfixes to the sources; @i "file name.inc"
    now works as expected; max line length is now 1024, not 100; a small
    bug if a line began @D or whatever has been fixed as well.

 -- Julian Gilbey <jdg@debian.org>  Tue, 15 Jan 2002 03:16:39 +0000

cweb (3.63a-1) unstable; urgency=low

  * After a discussion about the +e option with Knuth, he explained that
    it prevents ugly PDF bookmark output when CWEB files are processed
    with PDFTeX, but was unaware of the cweb-latex issue.  He added a
    comment to the manpage, but didn't change version number, so this
    version is being called 3.63a in Debian.
  * However, I have now majorly hacked the cwebmac.tex file so that it
    overcomes the PDF problem and am sending it upstream.  In the
    meantime, the +e option will remain on for the benefit of cweb-latex
    users, and PDFTeX users will not have the ugly bookmarks.
  * Howzat?!

 -- Julian Gilbey <jdg@debian.org>  Wed, 21 Nov 2001 12:57:59 +0000

cweb (3.63-4) unstable; urgency=low

  * Modified the cweave source to use the +e option by default; without
    this, cweb-latex breaks, and it does not make any difference to
    ordinary users. (Closes: #98517 against the cweb-latex package)
    (The +e option was silently introduced between versions 3.43 and 3.63)

 -- Julian Gilbey <jdg@debian.org>  Wed,  6 Jun 2001 16:53:39 +0100

cweb (3.63-3) unstable; urgency=low

  * Get the DEB_BUILD_OPTIONS stuff right

 -- Julian Gilbey <jdg@debian.org>  Tue,  8 May 2001 10:24:12 +0100

cweb (3.63-2) unstable; urgency=low

  * Improved DEB_BUILD_OPTIONS=debug behaviour

 -- Julian Gilbey <jdg@debian.org>  Tue,  8 May 2001 09:03:28 +0100

cweb (3.63-1) unstable; urgency=low

  * New upstream version
  * Change Recommends: to include g++ | c++-compiler
  * Standards version 3.5.0

 -- Julian Gilbey <jdg@debian.org>  Thu, 15 Feb 2001 01:11:20 +0000

cweb (3.62-1) unstable; urgency=low

  * New upstream version (closes: #64272)

 -- Julian Gilbey <jdg@debian.org>  Thu,  7 Dec 2000 15:59:39 +0000

cweb (3.43-7) unstable; urgency=low

  * Correct key-binding -> local-key-binding and correct syntax in cweb.el
    (closes: #63889)

 -- Julian Gilbey <jdg@debian.org>  Wed, 10 May 2000 13:38:19 +0100

cweb (3.43-6) unstable; urgency=low

  * Remove install-stamp target from debian/rules
  * Make cweb-mode emacs bindings local rather than global (closes:
    #41887)
  * Standards-version 3.1.1: Make cweb FHS compliant etc

 -- Julian Gilbey <jdg@debian.org>  Tue, 23 Nov 1999 11:49:10 +0000

cweb (3.43-5) unstable; urgency=low

  * Moved tex input files from /usr/lib/texmf to /usr/share/texmf in line
    with the change in tetex-*, moving towards FHS compliance
  * Moved /usr/lib/cweb to /usr/share/cweb similarly

 -- Julian Gilbey <jdg@debian.org>  Fri,  9 Apr 1999 12:04:07 +0100

cweb (3.43-4) unstable; urgency=low

  * Removed CVS files from diff file!

 -- Julian Gilbey <jdg@debian.org>  Thu, 25 Feb 1999 19:53:59 +0000

cweb (3.43-3) unstable; urgency=low

  * Changed gcc flags to -O2 -g -Wall as described in Policy 4.1

 -- Julian Gilbey <jdg@debian.org>  Sun,  7 Feb 1999 21:20:02 +0000

cweb (3.43-2) unstable; urgency=low

  * Moved macros to a litprog directory (both TeX and Emacs) in line with
    the other literate programming tools.
  * Changed Recommends and Suggests fields to recommend both a C compiler
    and teTeX, and to suggest CWEBx.

 -- Julian Gilbey <jdg@debian.org>  Wed, 27 Jan 1999 13:16:36 +0000

cweb (3.43-1) unstable; urgency=low

  * New upstream release.
  * New maintainer.
  * Modified debian/rules to use debhelper.
  * Included cwebman.dvi in docs directory.
  * Corrected location of cweb.el file to .../site-lisp/cweb/cweb.el in
    accordance with Debian emacs policy.  I haven't created a .elc file as
    I do not want to make this package dependent upon emacsen.
  * Standards 2.5.0.0.
  * Lintian 0.9.3 satisfied (except that it doesn't know about
    Standards 2.5.0.0 yet).

 -- Julian Gilbey <jdg@debian.org>  Thu, 12 Nov 1998 14:44:40 +0000

cweb (3.4g-15) frozen unstable; urgency=low

  * `cweb.el' moved to /usr/share/emacs/site-lisp/ (Bug #21220).
  * Standards 2.4.1.0.
  * Lintian 0.4.2 satisfied.

 -- Milan Zamazal <pdm@fi.muni.cz>  Thu, 16 Apr 1998 17:12:25 +0200

cweb (3.4g-14) unstable; urgency=low

  * Use `dh_md5sums'.
  * Lintian 0.2.2 satisfied.

 -- Milan Zamazal <pdm@fi.muni.cz>  Wed, 18 Feb 1998 19:02:39 +0100

cweb (3.4g-13) unstable; urgency=low

  * `checksums' renamed to `md5sums'.
  * Standards 2.4.0.0.

 -- Milan Zamazal <pdm@fi.muni.cz>  Fri, 13 Feb 1998 18:08:57 +0100

cweb (3.4g-12) unstable; urgency=low

  * `-isp' flag added to dpkg-gencontrol.


=== cweb/debian/control ===
Source: cweb
Section: devel
Priority: optional
Maintainer: Julian Gilbey <jdg@debian.org>
Standards-Version: 3.6.1
Build-Depends: debhelper

Package: cweb
Architecture: all
Depends: tetex-bin (>= 2.0.1-2)
Recommends: c-compiler | g++ | c++-compiler, tetex-base
Suggests: cwebx
Description: Dummy package for upgrade purposes only
 This is a dummy package which depends on tetex-bin, which now
 includes the CWEB suite of programs.

=== cweb/debian/rules ===
#!/usr/bin/make -f
# debian/rules for cweb package.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build:
	# Nothing to do

clean:
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdeb
	dh_gencontrol
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: build clean binary-indep binary-arch binary install
